unit Unit1;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, StdCtrls, Grids, Outline;

type
  TForm1 = class(TForm)
    Outline1: TOutline;
    Button1: TButton;
    procedure Outline1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);

    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
	public
  		bitmaps: array[1..5] of tbitmap;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Outline1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
	BitMap:		TBitMap;		 {for the item's bitmap }

	OffSet,
	VisibleCount,
	ActualIndex: Integer;


begin
    {draw on the control canvas, not on the form }
       { Find Item }
	VisibleCount := 0;
  	Offset:= 25;
   with OutLine1 do
   begin
   	for ActualIndex := 1 to ItemCount do begin
			if Items[ActualIndex].IsVisible then inc(VisibleCount);
			if Index = VisibleCount-1 then break;
		end;  { for }

		if ActualIndex = ItemCount then exit;
	 { rectangle }
{		Activate the following code to simulate a custom bitmap
		dependant on entry specific data}
{
		if ActualIndex = 4 then
			Bitmap := bitmaps[ActualIndex-1]
		else}
			Bitmap := bitmaps[ActualIndex];
		with Canvas do
			if Bitmap <> nil then
			begin
				BrushCopy(Bounds(Rect.Left + 2+ Items[ActualIndex].level * 10,
							Rect.Top, Bitmap.Width,
							Bitmap.Height), Bitmap,
							Bounds(0, 0, Bitmap.Width, bitmap.Height), clPurple);
{     four pixels between bitmap and text }
				Canvas.TextOut(Rect.Left + Offset + Items[ActualIndex].level * 10,
							Rect.Top,
							Items[ActualIndex].Text);
			end;
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	 with OutLine1 do begin
		AddObject(0, 'Level 1', Bitmaps[1]);
		AddChildObject(1, 'Level 2', Bitmaps[2]);

		AddChildObject(2, 'Level 3', Bitmaps[3]);
       AddChildObject(3, 'Level 4', Bitmaps[4]);
       AddChildObject(4, 'Level 5', Bitmaps[5]);
       AddChildObject(0, 'Level 1(a)', Bitmaps[1]);
	    FullExpand;
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	chdir(extractFilePath(Paramstr(0)));
	 bitmaps[1] := tbitmap.create;
	 bitmaps[2] := tbitmap.create;
	 bitmaps[3] := tbitmap.create;
	 bitmaps[4] := tbitmap.create;
	 bitmaps[5] := tbitmap.create;

	 bitmaps[1].loadfromfile('level1.bmp');
	 bitmaps[2].loadfromfile('level2.bmp');

	 bitmaps[3].loadfromfile('level3.bmp');
	 bitmaps[4].loadfromfile('level4.bmp');
	 bitmaps[5].loadfromfile('level5.bmp');
end;

end.

{This code was adapted from Lloyd's help file! (which didn't work<g>)}
